=== debian/changelog ===
convert3d (0.0.20170606-1~pre1~nd17.04+1) zesty; urgency=medium

  * Backported for zesty.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Mon, 19 Jun 2017 21:29:22 -0400

convert3d (0.0.20170606-1~pre1) neurodebian; urgency=medium

  * Initial release (Closes: #865126)

 -- Yaroslav Halchenko <debian@onerussian.com>  Mon, 19 Jun 2017 09:45:20 -0400
