=== debian/changelog ===
convert3d (0.0.20190204-1~nd80+1) jessie; urgency=medium

  * Backported for jessie.
  * Used following sed expression to modify debian/control: -e
    's/\(^Depends:\) */\1 neurodebian-popularity-contest, /g' -e
    's/^Maintainer:.*$/Maintainer: NeuroDebian Maintainers
    <team@neuro.debian.net>\nX-Original-&/'.

 -- NeuroDebian Maintainers <team@neuro.debian.net>  Thu, 01 Aug 2019 15:13:24 -0400

convert3d (0.0.20190204-1) neurodebian; urgency=medium

  * New upstream snapshot with 27 commits from previous point,
    primarily with bugfixes
  * debian/patches/up_link_gdcmDSED
    - adjusted for modularized by upstream CMakeLists.txt

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 01 Aug 2019 14:33:04 -0400
