=== debian/control ===
Source: convert3d
Section: science
Priority: optional
Maintainer: NeuroDebian Maintainers <team@neuro.debian.net>
X-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 9),
               help2man, cmake,
               libinsighttoolkit4-dev (>> 4.7.0~),
               qtbase5-dev,
               libgdcm-tools,
               libfftw3-dev,
               libtiff5-dev | libtiff4-dev | libtiff-dev,
               libpng-dev | libpng12-dev,
Standards-Version: 3.9.8
Homepage: https://sourceforge.net/projects/c3d/
Vcs-Git: https://anonscm.debian.org/git/pkg-exppsy/convert3d.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-exppsy/convert3d.git


Package: convert3d
Architecture: any
Depends: neurodebian-popularity-contest, ${shlibs:Depends}, ${misc:Depends}
Description: tool(s) for converting 3D images between common file formats
  C3D is a (command-line and GUI) tool for converting 3D images between common file
  formats. The tool also includes a growing list of commands for image
  manipulation, such as thresholding and resampling.
